Index: branches/src/ProcessManagement/ProcessManagement/Forms/Master/ConstructionType/FrmConstructionType.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/Master/ConstructionType/FrmConstructionType.cs	(revision 82)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/Master/ConstructionType/FrmConstructionType.cs	(revision 83)
@@ -1,11 +1,12 @@
 using System;
 using System.Collections.Generic;
+using System.Collections;
+using System.Linq;
 using System.ComponentModel;
 using System.Data;
 using System.Drawing;
 using System.Text;
 using System.Windows.Forms;
-using System.Collections;
 
 using log4net;
 using log4net.Appender;
@@ -18,7 +19,7 @@
 using ProcessManagement.Forms.SubForms;
 using ProcessManagement.Forms.CustomControls;
 using ProcessManagement.Forms.ControlsAction;
-//*------------------------ 構成マスタメンテ画面 ------------------------------*
+//*------------------------ 工事種別マスタメンテ画面 ------------------------------*
 //  2015/08/01  Ver1.0.0.0      Create Source           
 //  2015/09/05  Ver2.0.0.0      Create Source           
 //
@@ -46,7 +47,7 @@
         private const int s_MaxCode = 99999;
 
         /// <summary>
-        /// 表示順番
+        /// 一覧グリッドカラム順番
         /// </summary>
         private enum DispColumn
         {
@@ -56,6 +57,20 @@
             PublicFlg,
         }
 
+        /// <summary>
+        /// 経費グリッドカラム
+        /// </summary>
+        private enum ExpensesCol
+        {
+            Code = 0,
+            CheckFlg,
+            Name,
+            Rato
+        }
+
+        /// <summary>
+        /// コントロール定義
+        /// </summary>
         private enum DispCtrl
         {
             TypeCode = 0,
@@ -184,6 +199,9 @@
             // 公共工事コンボボックスセット
             SetPublicFlgCombBox();
 
+            // 選択許可区分コンボボックスセット
+            SetSecRankCombBox();
+            
             // グリッドデータ表示
             DispGridData();
 
@@ -312,7 +330,8 @@
         /// <param name="e"></param>
         private void btnDataDelete_Click(object sender, EventArgs e)
         {
-            IOMConstructionType typeDB = new IOMConstructionType();
+            IOMConstructionType TypeDB = new IOMConstructionType();
+            IOMTypeExpenses TypeExpDB = new IOMTypeExpenses();
             try
             {
                 // 選択無は削除できない
@@ -321,13 +340,27 @@
                 if (MessageBox.Show("表示中のデータを削除します。", "削除確認"
                     , MessageBoxButtons.YesNo, MessageBoxIcon.Information) != DialogResult.Yes) return;
 
-                string strSQL = typeDB.CreatePrimarykeyString(m_TypeCode);
-                if (!typeDB.DeleteAction(strSQL))
+                TypeDB.connect(); TypeDB.beginTran();
+                TypeExpDB.connect(); TypeExpDB.beginTran();
+
+                string strSQL = TypeDB.CreatePrimarykeyString(m_TypeCode);
+                if (!TypeDB.DeleteAction(strSQL, false))
                 {
-                    MessageBox.Show("削除に失敗しました。", "削除エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    TypeDB.rollback();
+                    MessageBox.Show("工事種別マスタ：削除に失敗しました。", "削除エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
                     return;
                 }
 
+                int Period = (int)numUDPeriod.Value;
+                strSQL = TypeExpDB.CreatePrimarykeyString(m_TypeCode, Period);
+                if (!TypeExpDB.DeleteAction(strSQL, false))
+                {
+                    TypeDB.rollback();
+                    TypeExpDB.rollback();
+                    MessageBox.Show("工事種別経費率マスタ：削除に失敗しました。", "削除エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
                 CommonMotions.RemoveEndMessage("工事種別データ");
 
                 // フィールドロック
@@ -356,7 +389,11 @@
             }
             finally
             {
-                typeDB.close(); typeDB = null;
+                TypeDB.commit();
+                TypeExpDB.commit();
+
+                TypeDB.close(); TypeDB = null;
+                TypeExpDB.close(); TypeExpDB = null;
             }
         }
         #endregion
@@ -567,29 +604,82 @@
         /// </summary>
         private void ClearDisplay()
         {
-            foreach (Control wrk in m_dispControl)
+            try
             {
-                if (CommonMotions.chkObjectIsNull(wrk)) continue;
-                if (!wrk.GetType().Equals(typeof(Button)))
+                foreach (Control wrk in m_dispControl)
+                {
+                    if (CommonMotions.chkObjectIsNull(wrk)) continue;
+                    if (wrk.GetType().Equals(typeof(Button))) continue;
+                 
                     wrk.Text = "";
+                }
+
+                // 新規時はコードを表示しない
+                if (m_TypeCode == 0)
+                {
+                    lblStaticItemCode.Visible = false;
+                    lblTypeCode.Visible = false;
+                }
+                else
+                {
+                    lblStaticItemCode.Visible = true;
+                    lblTypeCode.Visible = true;
+                }
+                cmbPublicFlg.SelectedIndex = -1;
+                m_bChengeAns = false;
+                TypeExpensesVisible(false);
             }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
 
-            // 新規時はコードを表示しない
-            if (m_TypeCode == 0)
+        #region 対象期セット処理
+        /// <summary>
+        /// 対象期セット処理
+        /// </summary>
+        private void SetInitnumUD()
+        {
+            try
             {
-                lblStaticItemCode.Visible = false;
-                lblTypeCode.Visible = false;
+                // 検索年度セット
+                // データにある事業期と現在の事業セット
+                int minval = 0;
+                int maxval = 0;
+                CommonMotions.GetPeriodYear(ref minval, ref maxval);
+                numUDPeriod.Minimum = minval;
+                numUDPeriod.Maximum = maxval;
+                numUDPeriod.Value = CommonMotions.SystemMasterData.BusinessPeriod;
             }
-            else
+            catch (System.Exception ex)
             {
-                lblStaticItemCode.Visible = true;
-                lblTypeCode.Visible = true;
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
-            cmbPublicFlg.SelectedIndex = -1;
-            m_bChengeAns = false;
         }
         #endregion
 
+        #region 種別毎経費コントロール表示
+        /// <summary>
+        /// 種別毎経費コントロール表示
+        /// </summary>
+        /// <param name="bVisibleFlg"></param>
+        private void TypeExpensesVisible(bool bVisibleFlg = true)
+        {
+            try
+            {
+                label3.Visible = bVisibleFlg;
+                numUDPeriod.Visible = bVisibleFlg;
+                dgvExpenses.Visible = bVisibleFlg;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
         #region 項目のチェック
         /// <summary>
         /// 画面項目のチェック
@@ -665,10 +755,12 @@
         private bool ConstructionTypeDataEntry()
         {
             IOMConstructionType typeDB = new IOMConstructionType();
+            IOMTypeExpenses typeExpDB = new IOMTypeExpenses();
             try
             {
                 //// 一括処理なので接続を行う
                 typeDB.connect(); typeDB.beginTran();
+                typeExpDB.connect(); typeExpDB.beginTran();
 
                 // 表示順を更新する
                 int idno = 0;
@@ -696,7 +788,9 @@
                 // データセット
                 ci.TypeCode = m_TypeCode;
                 ci.NameString = m_dispControl[(int)DispCtrl.TypeName].Text.ToString();
-                ci.PublicFlg = CommonMotions.cnvInt(((ComboBox)m_dispControl[(int)DispCtrl.PublicFlg]).SelectedValue.ToString());
+                ci.PublicFlg = CommonMotions.cnvInt(cmbPublicFlg.SelectedValue);
+                ci.SecRank = CommonMotions.cnvInt(cmbDataSecRank.SelectedValue);
+                if (radioButton1.Checked) ci.ExpensesLink = 0; else ci.ExpensesLink = 1;
                 ci.DeleteFlg = 0;
                 // 表示順はセットしない
                 ci.DisplayOrder = 0;
@@ -704,11 +798,11 @@
                 // SQL作成
                 string strSQL = typeDB.CreatePrimarykeyString(ci.TypeCode);
                 List<ConstructionTypeMaster> TypeList = new List<ConstructionTypeMaster>();
-                // 構成マスタ取得
+                // 工事種別マスタ取得
                 if (!typeDB.SelectAction(strSQL, ref TypeList, false))
                 {
                     typeDB.rollback();
-                    MessageBox.Show("登録確認に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    MessageBox.Show("工事種別マスタ：登録確認に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
                     return false;
                 }
 
@@ -716,15 +810,12 @@
                 {
                     // 表示順セット
                     ci.DisplayOrder = GetGridLineEffectivenessCount() + 1;
-                    // データがない場合は追加
-                    TypeList.Clear();
-                    TypeList.Add(ci);
 
                     // データ登録
                     if (!typeDB.InsertAction(ci, false))
                     {
                         typeDB.rollback();
-                        MessageBox.Show("登録に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        MessageBox.Show("工事種別マスタ：登録に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
                         return false;
                     }
                 }
@@ -736,13 +827,18 @@
                     if (!typeDB.UpdateAction(strSQL, ci, false))
                     {
                         typeDB.rollback();
-                        MessageBox.Show("更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        MessageBox.Show("工事種別マスタ：更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
                         return false;
                     }
                 }
 
-                // 成功したらcommit
-                typeDB.commit();
+                // 工事種別経費率マスタ更新
+                if (!UpdateTypeExpenses(typeExpDB))
+                {
+                    typeDB.rollback();
+                    typeExpDB.rollback();
+                    return false;
+                }
 
                 return true;
 
@@ -754,11 +850,107 @@
             }
             finally
             {
+                typeDB.commit();
+                typeExpDB.commit();
+
                 typeDB.close(); typeDB = null;
+                typeExpDB.close(); typeExpDB = null;
             }
         }
         #endregion
 
+        #region 工事種別経費率マスタ更新
+        /// <summary>
+        /// 工事種別経費率マスタ更新
+        /// </summary>
+        /// <returns></returns>
+        private bool UpdateTypeExpenses(IOMTypeExpenses typeExpDB)
+        {
+            try
+            {
+                // 年度取得
+                int Period = (int)numUDPeriod.Value;
+                string strSQL = typeExpDB.CreatePrimarykeyString(m_TypeCode, Period);
+
+                // 削除
+                typeExpDB.DeleteAction(strSQL, false);
+
+                // 経費が部署毎は登録しない
+                if (radioButton1.Checked) return true;
+
+                string strSubSQL = string.Empty;
+                bool bComma = false;
+                foreach (DataGridViewRow CurRow in dgvExpenses.Rows)
+                {
+                    if (CurRow.Cells[(int)ExpensesCol.CheckFlg].Value == null) continue;
+                    if (!(bool)CurRow.Cells[(int)ExpensesCol.CheckFlg].Value) continue;
+
+                    SetCostsRowDataSQL(CurRow, Period, bComma, ref strSubSQL);
+                    bComma = true;
+                }
+                // 対象データ無は書き込まない
+                if (strSubSQL.Length == 0) return true;
+
+                strSQL = "INSERT TypeExpensesMaster";
+                strSQL += " (";
+                bool bFirst = true;
+                foreach (var gender in Enum.GetValues(typeof(IOMTypeExpenses.NameColumn)))
+                {
+                    if (!bFirst) strSQL += " ,";
+                    strSQL += gender.ToString();
+                    bFirst = false;
+                }
+                strSQL += ") VALUES";
+
+                strSQL += strSubSQL;
+                if (!typeExpDB.ExecuteNonQuery(strSQL, false))
+                {
+                    MessageBox.Show("担当者毎経費データ登録に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 工事種別経費率マスタデータ取得
+        /// <summary>
+        /// 工事種別経費率マスタデータ取得
+        /// </summary>
+        /// <param name="dgvRow"></param>
+        /// <param name="Period"></param>
+        /// <param name="strSQL"></param>
+        private void SetCostsRowDataSQL(DataGridViewRow dgvRow, int Period, bool bComma, ref string strSQL)
+        {
+            try
+            {
+                if (bComma) strSQL += ", (";
+                else strSQL += " (";
+
+                strSQL += string.Format("  {0}", m_TypeCode);
+                strSQL += string.Format(", {0}", Period);
+                strSQL += string.Format(", {0}", CommonMotions.cnvInt(dgvRow.Cells[(int)ExpensesCol.Code].Value));
+                strSQL += string.Format(", {0}", CommonMotions.cnvDouble(dgvRow.Cells[(int)ExpensesCol.Rato].Value));
+                strSQL += ", 0";
+
+                strSQL += ", NOW()";
+                strSQL += ", NOW()";
+
+                strSQL += ")";
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
         #region グリッドデータ取得
         /// <summary>
         /// 作業名称グリッドデータ取得
@@ -782,26 +974,38 @@
 
                 // データ表示
                 string sflg = string.Empty;
+                string eflg = string.Empty;
                 int ino = 1;
                 foreach (ConstructionTypeMaster work in wrk)
                 {
                     // 工事種別を選択
-                    switch (work.PublicFlg){
+                    switch (work.PublicFlg)
+                    {
                         case (int)CommonDefine.ConstructionType.Other:
                             sflg = cmbPublicFlgString[0].Substring(0, 3);
                             break;
                         case (int)CommonDefine.ConstructionType.Community:
                             sflg = cmbPublicFlgString[1].Substring(0, 2);
-                        break;
+                            break;
                         case (int)CommonDefine.ConstructionType.Popular:
                             sflg = cmbPublicFlgString[2].Substring(0, 2);
-                        break;
+                            break;
                     }
-                    
+                    // 経費区分
+                    switch(work.ExpensesLink)
+                    {
+                        case 0:
+                            eflg = "部署";
+                            break;
+                        case 1:
+                            eflg = "種別";
+                            break;
+                    }
                     dgvWorkList.Rows.Add((ino++)
                                         , work.TypeCode
                                         , work.NameString
                                         , sflg
+                                        , eflg
                                         );
 
                 }
@@ -848,7 +1052,7 @@
                 // 新規時は表示しない
                 if (m_TypeCode == 0) return;
 
-                // 構成マスタ取得
+                // 工事種別マスタ取得
                 List<ConstructionTypeMaster> wrklist = new List<ConstructionTypeMaster>();
                 string strSQL = typeDB.CreatePrimarykeyString(m_TypeCode);
                 if (!typeDB.SelectAction(strSQL, ref wrklist)) return;
@@ -856,9 +1060,24 @@
                 if (wrklist.Count != 0)
                 {
                     // データ表示
-                    m_dispControl[(int)DispCtrl.TypeCode].Text = wrklist[0].TypeCode.ToString();                    // 種別コード
-                    m_dispControl[(int)DispCtrl.TypeName].Text = wrklist[0].NameString.ToString();                  // 種別名称
-                    ((ComboBox)m_dispControl[(int)DispCtrl.PublicFlg]).SelectedValue = wrklist[0].PublicFlg;        // 工事種別
+                    m_dispControl[(int)DispCtrl.TypeCode].Text = wrklist[0].TypeCode.ToString();        // 種別コード
+                    m_dispControl[(int)DispCtrl.TypeName].Text = wrklist[0].NameString.ToString();      // 種別名称
+                    cmbPublicFlg.SelectedValue = wrklist[0].PublicFlg;                                  // 工事種別
+                    cmbDataSecRank.SelectedValue = wrklist[0].SecRank;                                  // 選択機密区分
+                    if (wrklist[0].ExpensesLink == 0)
+                    {
+                        radioButton1.Checked = true;
+                        // コントロール表示
+                        TypeExpensesVisible(false);
+                    }
+                    else if (wrklist[0].ExpensesLink == 1)
+                    {
+                        radioButton2.Checked = true;
+                        // コントロール表示
+                        TypeExpensesVisible(true);
+                        // データ表示
+                        DspTypeExpenses();
+                    }
 
                     if (m_EditLock)
                         m_dispControl[(int)DispCtrl.EditMode].Text = CommonDefine.EditModeStringRef;                // 参照
@@ -886,6 +1105,60 @@
         }
         #endregion
 
+        #region 種別毎経費表示
+        /// <summary>
+        /// 種別毎経費表示
+        /// </summary>
+        private void DspTypeExpenses()
+        {
+            IOMTypeExpenses TypeExDB = new IOMTypeExpenses();
+            try
+            {
+                // 対象期セット
+                SetInitnumUD();
+
+                dgvExpenses.Rows.Clear();
+
+                // 工事種別経費率マスタ取得
+                int DivCode = CommonDefine.DivisionMasterCode.First(x => x.Value.Equals("工事経費名称登録")).Key;
+                ArrayList wrklist = new ArrayList();
+                string strSQL = "SELECT A.NAMECODE, A.NAMESTRING, B.TYPECODE, B.EXPENSESPERIOD, B.EXPENSESRAITO";
+                strSQL += " FROM DIVISIONMASTER A";
+                strSQL += string.Format(" LEFT JOIN TYPEEXPENSESMASTER B ON B.TYPECODE = {0} AND B.NAMECODE = A.NAMECODE AND B.DELETEFLG = 0", m_TypeCode);
+                strSQL += string.Format(" WHERE A.DIVISIONCODE = {0}", DivCode);
+                strSQL += " AND A.DELETEFLG = 0";
+                strSQL += " ORDER BY A.DISPLAYORDER";
+                
+                if (!TypeExDB.ExecuteReader(strSQL, ref wrklist)) return;
+                if (wrklist.Count == 0) return;
+
+                bool bChk = false;
+                int TypeCode = 0;
+                double ExpRate = 0;
+                foreach (object[] CurRec in wrklist)
+                {
+                    TypeCode = CommonMotions.cnvInt(CurRec[2]);
+                    ExpRate = CommonMotions.cnvDouble(CurRec[4]);
+                    if (TypeCode == 0) bChk = false;
+                    else bChk = true;
+                    dgvExpenses.Rows.Add(CommonMotions.cnvInt(CurRec[0]),
+                                            bChk,
+                                            CommonMotions.cnvString(CurRec[1]),
+                                            ExpRate.ToString("0.0"));
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                if (dgvExpenses.RowCount < 3) dgvExpenses.RowCount += (3 - dgvExpenses.RowCount);
+                TypeExDB.close(); TypeExDB = null;
+            }
+        }
+        #endregion
+
         #region 公共工事コンボボックスセット
         /// <summary>
         /// 公共工事コンボボックスセット
@@ -894,7 +1167,6 @@
         {
             try
             {
-
                 List<KeyValuePair<int, string>> DataList = new List<KeyValuePair<int, string>>();
                 // データ表示
                 for (int i = 0; i < cmbPublicFlgString.Length; i++)
@@ -913,6 +1185,41 @@
         }
         #endregion
 
+        #region 機密区分コンボボックス初期表示処理
+        /// <summary>
+        /// 機密区分コンボボックス初期表示処理
+        /// </summary>
+        private void SetSecRankCombBox()
+        {
+            try
+            {
+                // コンボボックスクリア
+                cmbDataSecRank.DataSource = null;
+                cmbDataSecRank.Items.Clear();
+
+                // 選択項目クリア
+                cmbDataSecRank.Text = "";
+
+                //コンボボックスのデータをセットする
+
+                List<KeyValuePair<int, string>> DataList = new List<KeyValuePair<int, string>>();
+                DataList.Add(new KeyValuePair<int, string>(0, ""));
+                foreach (KeyValuePair<int, string> wrk in CommonDefine.SecurityRankList)
+                {
+                    KeyValuePair<int, string> keyval = new KeyValuePair<int, string>(wrk.Key, wrk.Value);
+
+                    DataList.Add(keyval);
+                }
+                // コンボボックス初期表示
+                ComboBoxAction.InitDataSetCombBox(cmbDataSecRank, DataList);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
         #region 参照時ロック処理
         /// <summary>
         /// 参照時ロック処理
@@ -934,5 +1241,63 @@
             }
         }
         #endregion
+
+        #region 経費使用区分ラジオボタン
+        /// <summary>
+        /// 経費使用区分ラジオボタン
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void radioButton_CheckedChanged(object sender, EventArgs e)
+        {
+            try
+            {
+                if (radioButton1.Checked)
+                {
+                    // コントロール表示
+                    TypeExpensesVisible(false);
+                }
+                else
+                {
+                    // コントロール表示
+                    TypeExpensesVisible(true);
+                    // データ表示
+                    DspTypeExpenses();
+                }
+                m_bChengeAns = true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 営業期コンボボックス変更
+        /// <summary>
+        /// 営業期変更
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void numUDPeriod_ValueChanged(object sender, EventArgs e)
+        {
+            // データ表示
+            DspTypeExpenses();
+        }
+        #endregion
+
+        #region 経費率グリッド値変更
+        /// <summary>
+        /// 経費率グリッド値変更
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvExpenses_CellValidated(object sender, DataGridViewCellEventArgs e)
+        {
+            if (e.ColumnIndex != (int)ExpensesCol.Rato) return;
+            double dwork = CommonMotions.cnvDouble(dgvExpenses[e.ColumnIndex, e.RowIndex].Value);
+            dgvExpenses[e.ColumnIndex, e.RowIndex].Value = dwork.ToString("0.0");
+        }
+        #endregion
     }
 }
\ No newline at end of file
